#include "cplayer.h"

CPlayer::CPlayer(CGame *_Game)
{Snake=NULL;
 ScoreData=NULL;
 bActive=false;
 Game = _Game;
}

CPlayer::~CPlayer()
{stop();
}

void CPlayer::start(int _NR)
{NR=_NR;
 ScoreData=NULL;

 //Variablen (re)setten
 iTime=0;
 MomAction=0;
 bGameOver=false;

 VecX.x=1.0;
 VecX.y=0.0;
 VecX.z=0.0;
 VecY.x=0.0;
 VecY.y=1.0;
 VecY.z=0.0;
 VecZ.x=0.0;
 VecZ.y=0.0;
 VecZ.z=1.0;

 glLoadIdentity();
 glGetFloatv(GL_MODELVIEW_MATRIX,RotMatrix);
 glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
 glLoadIdentity();

 //Snake StartPos
 switch (NR)
 {  case 0: vPos.x=-Game->Options->iSpaceX; vPos.y=/*-Game->Options->iSpaceY*/0; vPos.z=0;
            RotateMatrix(RotMatrix,-90,VecY);
            RotateVec(&VecX,VecY,90);
            RotateVec(&VecZ,VecY,90);
            RotateMatrix(RotMatrix,180,VecZ);
            RotateVec(&VecX,VecZ,-180);
            RotateVec(&VecY,VecZ,-180);
            break;
    case 1: vPos.x=Game->Options->iSpaceX-1; vPos.y=/*-Game->Options->iSpaceY*/0; vPos.z=-1;
            RotateMatrix(RotMatrix,90,VecY);
            RotateVec(&VecX,VecY,-90);
            RotateVec(&VecZ,VecY,-90);
            RotateMatrix(RotMatrix,180,VecZ);
            RotateVec(&VecX,VecZ,-180);
            RotateVec(&VecY,VecZ,-180);
            break;
   /* case 2: vPos.x=-Game->Options->iSpaceX; vPos.y=+Game->Options->iSpaceY-1; vPos.z=0;
            RotateMatrix(RotMatrix,-90,VecY);
            RotateVec(&VecX,VecY,90);
            RotateVec(&VecZ,VecY,90);
            break;
    case 3: vPos.x=+Game->Options->iSpaceX-1; vPos.y=+Game->Options->iSpaceY-1; vPos.z=-1;
            RotateMatrix(RotMatrix,90,VecY);
            RotateVec(&VecX,VecY,-90);
            RotateVec(&VecZ,VecY,-90);
            break;
    case 4: vPos.x=-Game->Options->iSpaceX; vPos.y=0; vPos.z=-Game->Options->iSpaceZ;
            RotateMatrix(RotMatrix,-90,VecY);
            RotateVec(&VecX,VecY,90);
            RotateVec(&VecZ,VecY,90);
            RotateMatrix(RotMatrix,90,VecZ);
            RotateVec(&VecX,VecZ,-90);
            RotateVec(&VecY,VecZ,-90);
            break;
    case 5: vPos.x=+Game->Options->iSpaceX-1; vPos.y=-1; vPos.z=-Game->Options->iSpaceZ;
            RotateMatrix(RotMatrix,90,VecY);
            RotateVec(&VecX,VecY,-90);
            RotateVec(&VecZ,VecY,-90);
            RotateMatrix(RotMatrix,-90,VecZ);
            RotateVec(&VecX,VecZ,90);
            RotateVec(&VecY,VecZ,90);
            break;
    case 6: vPos.x=-Game->Options->iSpaceX; vPos.y=0; vPos.z=+Game->Options->iSpaceZ-1;
            RotateMatrix(RotMatrix,-90,VecY);
            RotateVec(&VecX,VecY,90);
            RotateVec(&VecZ,VecY,90);
            RotateMatrix(RotMatrix,-90,VecZ);
            RotateVec(&VecX,VecZ,90);
            RotateVec(&VecY,VecZ,90);
            break;
    case 7: vPos.x=+Game->Options->iSpaceX-1; vPos.y=-1; vPos.z=+Game->Options->iSpaceZ-1;
            RotateMatrix(RotMatrix,90,VecY);
            RotateVec(&VecX,VecY,-90);
            RotateVec(&VecZ,VecY,-90);
            RotateMatrix(RotMatrix,90,VecZ);
            RotateVec(&VecX,VecZ,-90);
            RotateVec(&VecY,VecZ,-90);
            break;
    case 8: vPos.x=0; vPos.y=-Game->Options->iSpaceY; vPos.z=-Game->Options->iSpaceZ;
            RotateMatrix(RotMatrix,180,VecZ);
            RotateVec(&VecX,VecZ,-180);
            RotateVec(&VecY,VecZ,-180);
            break;
    case 9: vPos.x=-1; vPos.y=-Game->Options->iSpaceY; vPos.z=+Game->Options->iSpaceZ-1;
            RotateMatrix(RotMatrix,180,VecY);
            RotateVec(&VecX,VecY,-180);
            RotateVec(&VecZ,VecY,-180);
            RotateMatrix(RotMatrix,180,VecZ);
            RotateVec(&VecX,VecZ,-180);
            RotateVec(&VecY,VecZ,-180);
            break;
    case 10: vPos.x=0; vPos.y=+Game->Options->iSpaceY-1; vPos.z=-Game->Options->iSpaceZ;
            RotateMatrix(RotMatrix,180,VecZ);
            RotateVec(&VecX,VecZ,-180);
            RotateVec(&VecY,VecZ,-180);
            RotateMatrix(RotMatrix,180,VecZ);
            RotateVec(&VecX,VecZ,-180);
            RotateVec(&VecY,VecZ,-180);
            break;
    case 11: vPos.x=-1; vPos.y=+Game->Options->iSpaceY-1; vPos.z=+Game->Options->iSpaceZ-1;
            RotateMatrix(RotMatrix,180,VecY);
            RotateVec(&VecX,VecY,-180);
            RotateVec(&VecZ,VecY,-180);
            break;*/
 }
 vTrans.x=vPos.x*20.0+10.0;
 vTrans.y=vPos.y*20.0+10.0;
 vTrans.z=vPos.z*20.0+10.0;

 Snake = new CSnake(Game);
 if (Game->Options->bSplit) Snake->Init(NR,vPos,NR,Game->Options->iStartLength);
 else Snake->Init(NR,vPos,Game->Options->iSnakeBody,Game->Options->iStartLength);

 if(Game->Options->bSplit) gluPerspective(Game->Options->iPerspective*10+30, (GLfloat)Game->Options->iWidth/2/(GLfloat)Game->Options->iHeight, 0.1, 10000.0);

 bActive=true;
}

void CPlayer::stop()
{if (Snake) delete Snake;
 Snake=NULL;
 if (ScoreData) delete ScoreData;
 ScoreData=NULL;
 bActive=false;
}

void CPlayer::calculate()
{if (!bActive) return;
 if (bGameOver) return;

 SVector3i vNewPos;
 if (MomAction==0)
 {  vTrans.x+=VecZ.x*Game->fStep;
    vTrans.y+=VecZ.y*Game->fStep;
    vTrans.z+=VecZ.z*Game->fStep;
 }
 else if (abs(MomAction)==1)
 {  if (iTime==0)
    {  ZCorrection=20-fmod(vTrans.x*VecZ.x+vTrans.y*VecZ.y+vTrans.z*VecZ.z+2010.0,20.0);
       RotAngle=90.0/(10.0/Game->fStep);
       for (int i=0;i<16;++i) BaseRotMatrix[i]=RotMatrix[i];
       NextVecZ=VecZ;
       RotateVec(&NextVecZ,VecX,-90*MomAction);
       vTransNext.x=vPos.x*20.0+10.0;
       vTransNext.y=vPos.y*20.0+10.0;
       vTransNext.z=vPos.z*20.0+10.0;
       if(ZCorrection>=10)
       {  vTransNext.x+=VecZ.x*20.0;
          vTransNext.y+=VecZ.y*20.0;
          vTransNext.z+=VecZ.z*20.0;
       }
       ZCorrection/=(10.0/Game->fStep);
    }
    ++iTime;
    for (int i=0;i<16;++i) RotMatrix[i]=BaseRotMatrix[i];
    RotateMatrix(RotMatrix,RotAngle*iTime*MomAction,VecX);
    vTrans.x+=VecZ.x*ZCorrection;
    vTrans.y+=VecZ.y*ZCorrection;
    vTrans.z+=VecZ.z*ZCorrection;

    if(iTime>=10.0/Game->fStep)
    {  for (int i=0;i<16;++i) RotMatrix[i]=BaseRotMatrix[i];
       RotateMatrix(RotMatrix,90*MomAction,VecX);
       RotateVec(&VecY,VecX,-90*MomAction);
       RotateVec(&VecZ,VecX,-90*MomAction);
       vTrans=vTransNext;
       MomAction=0;
       iTime=0;
       //fprintf(stderr,"Pos","%i,%i,%i\n%i,%i,%i\n%.2f,%.2f,%.2f",vPos.x,vPos.y,vPos.z, vNewPos.x,vNewPos.y,vNewPos.z, vTrans.x,vTrans.y,vTrans.z);
    }
 }
 else if (abs(MomAction)==2)
 {  if (iTime==0)
    {  RotAngle=90.0/(10.0/Game->fStep);
       for (int i=0;i<16;++i) BaseRotMatrix[i]=RotMatrix[i];
    }
    vTrans.x+=VecZ.x*Game->fStep;
    vTrans.y+=VecZ.y*Game->fStep;
    vTrans.z+=VecZ.z*Game->fStep;
    ++iTime;
    for (int i=0;i<16;++i) RotMatrix[i]=BaseRotMatrix[i];
    RotateMatrix(RotMatrix,RotAngle*iTime*MomAction/2.0,VecZ);
    if(iTime>=10.0/Game->fStep)
    {  for (int i=0;i<16;++i) RotMatrix[i]=BaseRotMatrix[i];
       RotateMatrix(RotMatrix,90*MomAction/2,VecZ);
       RotateVec(&VecX,VecZ,-90*MomAction/2);
       RotateVec(&VecY,VecZ,-90*MomAction/2);
       MomAction=0;
       iTime=0;
       //fprintf(stderr,"Pos","%i,%i,%i\n%i,%i,%i\n%.2f,%.2f,%.2f",vPos.x,vPos.y,vPos.z, vNewPos.x,vNewPos.y,vNewPos.z, vTrans.x,vTrans.y,vTrans.z);
    }
 }
 else if (abs(MomAction)==3)
 {  if (iTime==0)
    {  ZCorrection=20-fmod(vTrans.x*VecZ.x+vTrans.y*VecZ.y+vTrans.z*VecZ.z+2010.0,20.0);
       RotAngle=90.0/(10.0/Game->fStep);
       for (int i=0;i<16;++i) BaseRotMatrix[i]=RotMatrix[i];
       NextVecZ=VecZ;
       RotateVec(&NextVecZ,VecY,-90*MomAction/3.0);
       vTransNext.x=vPos.x*20.0+10.0;
       vTransNext.y=vPos.y*20.0+10.0;
       vTransNext.z=vPos.z*20.0+10.0;
       if(ZCorrection>=10)
       {  vTransNext.x+=VecZ.x*20.0;
          vTransNext.y+=VecZ.y*20.0;
          vTransNext.z+=VecZ.z*20.0;
       }
       ZCorrection/=(10.0/Game->fStep);
    }
    ++iTime;
    for (int i=0;i<16;++i) RotMatrix[i]=BaseRotMatrix[i];
    RotateMatrix(RotMatrix,RotAngle*iTime*MomAction/3.0,VecY);
    vTrans.x+=VecZ.x*ZCorrection;
    vTrans.y+=VecZ.y*ZCorrection;
    vTrans.z+=VecZ.z*ZCorrection;

    if(iTime>=10.0/Game->fStep)
    {  for (int i=0;i<16;++i) RotMatrix[i]=BaseRotMatrix[i];
       RotateMatrix(RotMatrix,90*MomAction/3.0,VecY);
       RotateVec(&VecX,VecY,-90*MomAction/3.0);
       RotateVec(&VecZ,VecY,-90*MomAction/3.0);
       vTrans=vTransNext;
       MomAction=0;
       iTime=0;
       //fprintf(stderr,"Pos","%i,%i,%i\n%i,%i,%i\n%.2f,%.2f,%.2f",vPos.x,vPos.y,vPos.z, vNewPos.x,vNewPos.y,vNewPos.z, vTrans.x,vTrans.y,vTrans.z);
    }
 }
 else fprintf(stderr,"unbekannte MomAction: %i\n",MomAction);

 //vTrans muss >0 gemachtwerden sonst stimmt was bei der Rundung nicht
 //richting bis vTrans>-2000
 vNewPos.x=(int)((vTrans.x+2000.0)/20.0)-100;
 vNewPos.y=(int)((vTrans.y+2000.0)/20.0)-100;
 vNewPos.z=(int)((vTrans.z+2000.0)/20.0)-100;

 bool diff=false;
 if (vNewPos.x - vPos.x != 0) diff=true;
 else if (vNewPos.y - vPos.y != 0) diff=true;
 else if (vNewPos.z - vPos.z != 0) diff=true;

 if (diff)
 {  if ((vNewPos.x<-Game->Options->iSpaceX)||(vNewPos.y<-Game->Options->iSpaceY)||(vNewPos.z<-Game->Options->iSpaceZ)||
        (vNewPos.x>=Game->Options->iSpaceX)||(vNewPos.y>=Game->Options->iSpaceY)||(vNewPos.z>=Game->Options->iSpaceZ))
    {  GameOver(0); return;  }
    bool bInTarget=false;
    if (Game->Target)
    {  if (Game->Target->angekommen(vNewPos))
       {  bInTarget=true;
          Game->Target->CreateNew();
          if(Game->Options->bSound) Game->play();
       }
    } else fprintf(stderr,"kein Target\n");
    Snake->move(vNewPos,bInTarget);

    for (int i=0;i<Game->Options->iPlayerCount;++i) if (Game->Player[i]->Snake->InElement(vNewPos,(NR!=i))) {  GameOver(1); return;  }

    vPos=vNewPos;
 }
}

void CPlayer::draw()
{if (!bActive) return;

 if (Game->bBreak) glDisable(GL_LIGHT0);
 else glEnable(GL_LIGHT0);

 if(Game->bBeginning) glDisable(GL_LIGHT0);
 else
 {  glEnable(GL_LIGHT0);
    if (Game->Target) Game->Target->setLightPos(NR);
 }

 glLoadIdentity();
 glMultMatrixf(RotMatrix);
 glTranslatef(vTrans.x,vTrans.y,vTrans.z);

 if(Game->Options->iBkgnd!=2)
 {  glColor3ub(255,255,255);
    glBindTexture(GL_TEXTURE_2D,Game->Texture[2+Game->Options->iBkgnd]);
    drawCube2(Game->Options->iSpaceX*20,Game->Options->iSpaceY*20,Game->Options->iSpaceZ*20,(11-Game->Options->iPictureSize)/100.0,false,16);
 }
 else
 {  glColor3ub(255,255,255);
    glBindTexture(GL_TEXTURE_2D,Game->Texture[7]);//0);
    drawCube2(Game->Options->iSpaceX*20,Game->Options->iSpaceY*20,Game->Options->iSpaceZ*20,(11-Game->Options->iPictureSize)/100.0,false,16);
 }

 for(int i=0;i<Game->Options->iPlayerCount;++i) Game->Player[i]->Snake->draw((i!=NR),NR);

 if (bGameOver)
 {  ++iTime;

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluOrtho2D(0,Game->Options->iWidth,Game->Options->iHeight,0);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    glDisable(GL_LIGHTING);

    glColor4ub(255,0,0,iTime*2+55);
    glBindTexture(GL_TEXTURE_2D,0);

    glBegin(GL_QUADS);
      glVertex2i(0,0);
      glVertex2i(Game->Options->iWidth,0);
      glVertex2i(Game->Options->iWidth,Game->Options->iHeight);
      glVertex2i(0,Game->Options->iHeight);
    glEnd();

    glEnable(GL_LIGHTING);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    if(Game->Options->bSplit) gluPerspective(Game->Options->iPerspective*10+30, (GLfloat)Game->Options->iWidth/2/(GLfloat)Game->Options->iHeight, 0.1, 10000.0);
    else gluPerspective(Game->Options->iPerspective*10+30, (GLfloat)Game->Options->iWidth/(GLfloat)Game->Options->iHeight, 0.1, 10000.0);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

    if(iTime>=100) {bActive=false; return;}
 }
 else if(Game->bBreak)
 {  glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluOrtho2D(0,Game->Options->iWidth,Game->Options->iHeight,0);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    glDisable(GL_LIGHTING);

    glColor3ub(255,255,255);
    glBindTexture(GL_TEXTURE_2D,Game->Texture[6]);

    glBegin(GL_QUADS);
      glTexCoord2f(0.0, 1.0); glVertex2i((Game->Options->iWidth-400)/2,(Game->Options->iHeight-200)/2);
      glTexCoord2f(1.0, 1.0); glVertex2i((Game->Options->iWidth-400)/2+400,(Game->Options->iHeight-200)/2);
      glTexCoord2f(1.0, 0.0); glVertex2i((Game->Options->iWidth-400)/2+400,(Game->Options->iHeight-200)/2+200);
      glTexCoord2f(0.0, 0.0); glVertex2i((Game->Options->iWidth-400)/2,(Game->Options->iHeight-200)/2+200);
    glEnd();

    glEnable(GL_LIGHTING);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    if(Game->Options->bSplit) gluPerspective(Game->Options->iPerspective*10+30, (GLfloat)Game->Options->iWidth/2/(GLfloat)Game->Options->iHeight, 0.1, 10000.0);
    else gluPerspective(Game->Options->iPerspective*10+30, (GLfloat)Game->Options->iWidth/(GLfloat)Game->Options->iHeight, 0.1, 10000.0);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
 }
 else if (Game->bBeginning)
 {  ++iTime;

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluOrtho2D(0,Game->Options->iWidth,Game->Options->iHeight,0);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    glDisable(GL_LIGHTING);

    glColor3ub(255,255,255);
    if (iTime < 50) glBindTexture(GL_TEXTURE_2D,Game->Texture[4]);
    else glBindTexture(GL_TEXTURE_2D,Game->Texture[5]);

    glBegin(GL_QUADS);
      glTexCoord2f(0.0, 1.0); glVertex2i((Game->Options->iWidth-400)/2,(Game->Options->iHeight-200)/2);
      glTexCoord2f(1.0, 1.0); glVertex2i((Game->Options->iWidth-400)/2+400,(Game->Options->iHeight-200)/2);
      glTexCoord2f(1.0, 0.0); glVertex2i((Game->Options->iWidth-400)/2+400,(Game->Options->iHeight-200)/2+200);
      glTexCoord2f(0.0, 0.0); glVertex2i((Game->Options->iWidth-400)/2,(Game->Options->iHeight-200)/2+200);
    glEnd();

    glEnable(GL_LIGHTING);

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    if(Game->Options->bSplit) gluPerspective(Game->Options->iPerspective*10+30, (GLfloat)Game->Options->iWidth/2/(GLfloat)Game->Options->iHeight, 0.1, 10000.0);
    else gluPerspective(Game->Options->iPerspective*10+30, (GLfloat)Game->Options->iWidth/(GLfloat)Game->Options->iHeight, 0.1, 10000.0);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();


    if(iTime>=70)
    {  iTime=0;
       glEnable(GL_LIGHT0);
       Game->bBeginning=false;
    }
 }

 if(!Game->bBeginning) if (Game->Target) Game->Target->draw(NR);

}

void CPlayer::GameOver(int art)
{
    if(!ScoreData)
 {  ScoreData = new SScoreData;
    ScoreData->iVelocity = Game->Options->iVelocity;
    ScoreData->iSpace = Game->Options->iSpaceX * Game->Options->iSpaceY * Game->Options->iSpaceZ;
    ScoreData->iStartLength = Game->Options->iStartLength;
    ScoreData->iTargetSize = Game->Options->iTargetSize;
    ScoreData->iCollected = Snake->iCollected;
    ScoreData->iScore = (int)((float)(ScoreData->iVelocity*ScoreData->iCollected+(Snake->nextElement.size()-ScoreData->iCollected)*ScoreData->iVelocity/5.0)
                     * pow(ScoreData->iSpace/125.0,-0.2) * pow(ScoreData->iTargetSize,-0.5));
 }
 if (art>-1) //d.h. am GO schuld
 {  ++Game->iPlayerGO;
    bGameOver=true;
    iTime=0;
    if(Game->iPlayerGO >= Game->Options->iPlayerCount)
    {  for (int i=0;i<Game->Options->iPlayerCount;++i) if(i!=NR) Game->Player[i]->GameOver(-1);//nicht am GO schuld
       Game->bGameOver=true;
    }
 }
}

void CPlayer::input(int in)
{
    if((MomAction==0)&&(!Game->bBreak)) switch(in)
 {  case 1: //up
            if(Game->Options->bReverseY) MomAction=1;
            else MomAction=-1;
            iTime=0;
            break;
    case 2: //down
            if(Game->Options->bReverseY) MomAction=-1;
            else MomAction=1;
            iTime=0;
            break;
    case 3: //left
            if(Game->Options->bLRTurn) MomAction=-3;
            else MomAction=-2;
            iTime=0;
            break;
    case 4: //right
            if(Game->Options->bLRTurn) MomAction=3;
            else MomAction=2;
            iTime=0;
            break;
 }
}

void CPlayer::RotateMatrix(float* in, float angle, SVector3f r)
{//if(Matrix ist keine 4x4 Matrix) return false;
 angle=angle/180.0*M_PI;
 bool b=false;
 r.x=round(r.x);
 r.y=round(r.y);
 r.z=round(r.z);
 float rot[16];
 float result[16];
 for (int i=0;i<16;++i) rot[i]=0;
 if ((fabs(r.x)==1)&&(r.y==0)&&(r.z==0))
 {  rot[0]=1;
    rot[15]=1;
    rot[5]=round(cos(angle*r.x)*100.0)/100.0;
    rot[6]=round(sin(angle*r.x)*100.0)/100.0;
    rot[9]=round(-sin(angle*r.x)*100.0)/100.0;
    rot[10]=round(cos(angle*r.x)*100.0)/100.0;
    Mult4x4Matrix(result,rot,in);
    b=true;
 }
 else if ((fabs(r.y)==1)&&(r.x==0)&&(r.z==0))
 {  rot[5]=1;
    rot[15]=1;
    rot[0]=round(cos(angle*r.y)*100.0)/100.0;
    rot[8]=round(sin(angle*r.y)*100.0)/100.0;
    rot[2]=round(-sin(angle*r.y)*100.0)/100.0;
    rot[10]=round(cos(angle*r.y)*100.0)/100.0;
    Mult4x4Matrix(result,rot,in);
    b=true;
 }
 else if ((fabs(r.z)==1)&&(r.y==0)&&(r.x==0))
 {  rot[10]=1;
    rot[15]=1;
    rot[0]=round(cos(angle*r.z)*100.0)/100.0;
    rot[1]=round(sin(angle*r.z)*100.0)/100.0;
    rot[4]=round(-sin(angle*r.z)*100.0)/100.0;
    rot[5]=round(cos(angle*r.z)*100.0)/100.0;
    Mult4x4Matrix(result,rot,in);
    b=true;
 }
 for (int i=0;i<16;++i) in[i]=result[i];
 if(!b) fprintf(stderr,"Problem: RotateMatrix hat nix gemacht\n");

}

void CPlayer::Mult4x4Matrix(float* M,float* A,float* B)
{for (int i=0;i<16;++i) M[i]=0;
 for (int i=0;i<4;++i)
 for (int j=0;j<4;++j)
 for (int k=0;k<4;++k)
 M[j*4+i]+=A[j*4+k]*B[k*4+i];
}

void CPlayer::RotateVec(SVector3f* vec, SVector3f rot, float angle)
{float abs,richt;
 angle=angle/180*M_PI;
 bool b=false;
 if ((fabs(rot.x)==1)&&(rot.y==0)&&(rot.z==0))
 {  if (rot.x==-1) angle=-angle;
    abs=sqrt(vec->y*vec->y+vec->z*vec->z);
    richt=getAngle(vec->y,vec->z);
    vec->y=cos(richt+angle)*abs;
    vec->z=sin(richt+angle)*abs;
    b=true;
 }
 else if ((fabs(rot.y)==1)&&(rot.x==0)&&(rot.z==0))
 {  if (rot.y==-1) angle=-angle;
    abs=sqrt(vec->x*vec->x+vec->z*vec->z);
    richt=getAngle(vec->z,vec->x);
    vec->z=cos(richt+angle)*abs;
    vec->x=sin(richt+angle)*abs;
    b=true;
 }
 else if ((fabs(rot.z)==1)&&(rot.x==0)&&(rot.y==0))
 {  if (rot.z==-1) angle=-angle;
    abs=sqrt(vec->y*vec->y+vec->x*vec->x);
    richt=getAngle(vec->x,vec->y);
    vec->x=cos(richt+angle)*abs;
    vec->y=sin(richt+angle)*abs;
    b=true;
 }
 vec->x=round(vec->x);
 vec->y=round(vec->y);
 vec->z=round(vec->z);
 if(!b) fprintf(stderr,"Problem: RotateVec hat nix gemacht\n%e,%e,%e\n%e,%e,%e\n%e\n",vec->x,vec->y,vec->z,rot.x,rot.y,rot.z,angle);
}

float CPlayer::getAngle(float x,float y)
{float w;
 if (x==0) w=M_PI/2.0;
 else w=atan(fabs(y/x));
 if (x<0) w=M_PI-w;
 if (y<0) w=2.0*M_PI-w;
 return w;
}

void CPlayer::drawCube2(float x, float y, float z, float fPicture, bool NormalOut, int q)
{ int n=1;
  if (NormalOut) n=-1;
     glBegin(GL_QUADS); // fange an Quadrate zu zeichnen
     for(int i=0;i<q;++i) for(int j=0;j<q;++j)
     {
     // obere Seite
     glNormal3f(0.0,-1*n,0.0);
     glTexCoord2f(fPicture*x/q*(i),     fPicture*z/q*(j)); glVertex3f(-x+2*x/q*i, y, -z+2*z/q*j); // oben links der Tex/q*itur und des Quadrates
     glTexCoord2f(fPicture*x/q*(i),     fPicture*z/q*(j+1));     glVertex3f(-x+2*x/q*i, y, -z+2*z/q*(j+1)); // unten links der Tex/q*itur und des Quadrates
     glTexCoord2f(fPicture*x/q*(i+1), fPicture*z/q*(j+1));     glVertex3f(-x+2*x/q*(i+1), y, -z+2*z/q*(j+1)); // unten rechts der Tex/q*itur und des Quadrates
     glTexCoord2f(fPicture*x/q*(i+1), fPicture*z/q*(j)); glVertex3f(-x+2*x/q*(i+1), y, -z+2*z/q*j); // oben rechts der Textur und des Quadrates
     }
     for(int i=0;i<q;++i) for(int j=0;j<q;++j)
     {
     // untere Seite
     glNormal3f(0.0,n,0.0);
     glTexCoord2f(fPicture*x/q*(i)  , fPicture*z/q*(j)); glVertex3f(-x+2*x/q*i,-y, -z+2*z/q*j); // oben rechts der Tex/q*itur und des Quadrates
     glTexCoord2f(fPicture*x/q*(i+1), fPicture*z/q*(j)); glVertex3f(-x+2*x/q*(i+1),-y, -z+2*z/q*j); // oben links der Tex/q*itur und des Quadrates
     glTexCoord2f(fPicture*x/q*(i+1), fPicture*z/q*(j+1)); glVertex3f(-x+2*x/q*(i+1),-y,-z+2*z/q*(j+1)); // unten links der Tex/q*itur und des Quadrates
     glTexCoord2f(fPicture*x/q*(i)  , fPicture*z/q*(j+1)); glVertex3f(-x+2*x/q*i,-y,-z+2*z/q*(j+1)); // unten rechts der Textur und des Quadrates
     }
     for(int i=0;i<q;++i) for(int j=0;j<q;++j)
     {
     // vordere Seite
     glNormal3f(0.0,0.0,-1*n);
     glTexCoord2f(fPicture*x/q*i    , fPicture*y/q*j); glVertex3f(-x+2*x/q*i,-y+2*y/q*j, z); // unten links der Tex/q*itur und des Quadrates
     glTexCoord2f(fPicture*x/q*(i+1), fPicture*y/q*j); glVertex3f(-x+2*x/q*(i+1),-y+2*y/q*j, z); // unten rechts der Tex/q*itur und des Quadrates
     glTexCoord2f(fPicture*x/q*(i+1), fPicture*y/q*(j+1)); glVertex3f(-x+2*x/q*(i+1),-y+2*y/q*(j+1), z); // oben rechts der Tex/q*itur und des Quadrates
     glTexCoord2f(fPicture*x/q*i    , fPicture*y/q*(j+1)); glVertex3f(-x+2*x/q*i,-y+2*y/q*(j+1), z); // oben links der Tex/q*itur und des Quadrates
     }
     for(int i=0;i<q;++i) for(int j=0;j<q;++j)
     {
     // hintere Seite
     glNormal3f(0.0,0.0,n);
     glTexCoord2f(fPicture*x/q*(i)  , fPicture*y/q*j); glVertex3f(-x+2*x/q*i,-y+2*y/q*j, -z); // unten rechts der Tex/q*itur und des Quadrates
     glTexCoord2f(fPicture*x/q*(i)  , fPicture*y/q*(j+1)); glVertex3f(-x+2*x/q*i,-y+2*y/q*(j+1), -z); // oben rechts der Tex/q*itur und des Quadrates
     glTexCoord2f(fPicture*x/q*(i+1), fPicture*y/q*(j+1)); glVertex3f(-x+2*x/q*(i+1),-y+2*y/q*(j+1), -z); // oben links der Tex/q*itur und des Quadrates
     glTexCoord2f(fPicture*x/q*(i+1), fPicture*y/q*j); glVertex3f(-x+2*x/q*(i+1),-y+2*y/q*j, -z); // unten links der Textur und des Quadrates
     }
     for(int i=0;i<q;++i) for(int j=0;j<q;++j)
     {
     // rechte Seite
     glNormal3f(-1*n,0.0,0.0);
     glTexCoord2f(fPicture*z/q*(i)  , fPicture*y/q*j); glVertex3f( x,-y+2*y/q*j, -z+2*z/q*i); // unten rechts der Textur und des Quadrates
     glTexCoord2f(fPicture*z/q*(i)  , fPicture*y/q*(j+1)); glVertex3f( x,-y+2*y/q*(j+1), -z+2*z/q*i); // oben rechts der Textur und des Quadrates
     glTexCoord2f(fPicture*z/q*(i+1), fPicture*y/q*(j+1)); glVertex3f( x,-y+2*y/q*(j+1),-z+2*z/q*(i+1)); // oben links der Textur und des Quadrates
     glTexCoord2f(fPicture*z/q*(i+1), fPicture*y/q*j); glVertex3f( x,-y+2*y/q*j,-z+2*z/q*(i+1)); // unten links der Textur und des Quadrates
     }
     for(int i=0;i<q;++i) for(int j=0;j<q;++j)
     {
     // linke Seite
     glNormal3f(n,0.0,0.0);
     glTexCoord2f(fPicture*z/q*i    , fPicture*y/q*j); glVertex3f(-x,-y+2*y/q*j, -z+2*z/q*i); // unten links der Textur und des Quadrates
     glTexCoord2f(fPicture*z/q*(i+1), fPicture*y/q*j); glVertex3f(-x,-y+2*y/q*j,-z+2*z/q*(i+1)); // unten rechts der Textur und des Quadrates
     glTexCoord2f(fPicture*z/q*(i+1), fPicture*y/q*(j+1)); glVertex3f(-x,-y+2*y/q*(j+1),-z+2*z/q*(i+1)); // oben rechts der Textur und des Quadrates
     glTexCoord2f(fPicture*z/q*i    , fPicture*y/q*(j+1)); glVertex3f(-x,-y+2*y/q*(j+1), -z+2*z/q*i); // oben links der Textur und des Quadrates
     }
   glEnd();
}
