#ifndef SPLITSCORE_H
#define SPLITSCORE_H

#include <QtGui/QWidget>
#include "globalstructs.h"

namespace Ui {
    class splitScore;
}

class splitScore : public QWidget {
    Q_OBJECT
public:
    splitScore(SScoreData *, QWidget *parent = 0);
    ~splitScore();

protected:
    void changeEvent(QEvent *e);

private:
    Ui::splitScore *m_ui;
    SScoreData *scr;
    int winner;
    void fillTable();

signals:
    void enterScore(SScoreData);

private slots:
    void goOn();
};

#endif // SPLITSCORE_H
