#ifndef _targa_h_
#define _targa_h_


#include <stdio.h>
//#include <malloc.h>


/* make sure these types reflect your system's type sizes. */
#define byte    char
#define int32   int
#define int16   short

#define ubyte   unsigned byte
#define uint32  unsigned int32
#define uint16  unsigned int16


#define TGA_TRUECOLOR_32      (4)



#ifdef __cplusplus
extern "C" {
#endif


/* Error handling routines */
int             tga_get_last_error();
const char *    tga_error_string( int error_code );


void * tga_load( const char * file, int * width, int * height );



#ifdef __cplusplus
}
#endif


#endif /* _targa_h_ */
