#ifndef CGAME_H_
#define CGAME_H_


#include <QtOpenGL>
#include <QImage>

struct SVector3f { float x,y,z; };
struct SVector3i { int x,y,z; };
class CGame;
class CPlayer;
class CSnake;
class CTarget;

#include "globalStructs.h"
#include "cplayer.h"
#include "ctarget.h"





class CGame
{


public:
   CGame();
   ~CGame();
   void TimerFunc();
   void HandleEvent(/*SDL_Event**/);
   void start(SOptions*);
   void play();
   void ChangeActiveClass(int); //Wechsel zu anderer Aktiven Klasse
   void collectScore();
   void getScore(SScoreData *);
  

     
   GLUquadricObj* quadric;

   CTarget *Target;
   CPlayer **Player;
   
   GLuint *Texture;
   bool bActive,bBreak,bGameOver,bBeginning; 
   int iTime;
   float fStep;
   SOptions *Options;
   bool bGetScore;
   
   //SDL_AudioSpec spec;

   int iPlayerGO;
   
   
   void stop();
   void draw(); //malen durch UE_DRAW aufgerufen
   void calculate(); //berechnungen direkt vom Timer aufgerufen

   bool LoadPNGs(const int anzahl, const char* pfad[], bool linear[], GLuint *textur);
   
};
























#endif
