#ifndef CSNAKE_H
#define CSNAKE_H

#include <QtOpenGL>
#include "globalStructs.h"
#include "cgame.h"

class CSnake
{public:
   CSnake(CGame *);
   ~CSnake();
   void Init(int,SVector3i,int,int);
   void draw(bool,int);

   void move(SVector3i,bool);
   bool InElement(SVector3i,bool);
   SVector3i getPos(int n);
   void drawConnected(SVector3i,SVector3i);
   void searchConnected();
   void drawPyramide(int s,SVector3f VecX,SVector3f VecY,SVector3f VecZ);
   void RotateVec(SVector3f* vec, SVector3f rot, float angle);
   float getAngle(float x,float y);
   void drawCube(float x, float y, float z, float fPicture, bool NormalOut);


   CGame *Game;
   std::vector<SVector3i> Pos1, Pos2;
   bool bActive;
   SVector3i firstElement;
   std::vector<char> nextElement;
   int iBody;
   int iElementsLeft;
   int iCollected;
   int NR;
   int iDirection; //nur fr network
};

#endif // CSNAKE_H
