#ifndef HIGHSCORE_H
#define HIGHSCORE_H

#include <QtGui/QWidget>
#include "globalStructs.h"
#include <stdio.h>

namespace Ui {
    class Highscore;
}

class Highscore : public QWidget {
    Q_OBJECT
public:
    Highscore(SScoreData *, QWidget *parent = 0);
    Highscore(SScoreData *, SScoreData , QWidget *parent = 0);
    ~Highscore();

protected:
    void changeEvent(QEvent *e);

private:
    Ui::Highscore *m_ui;
    void fillTable();
    int insertScore(SScoreData scr);
    int nr;
    SScoreData *top10;

public slots:
    void back();
    void enteredName();
    void nameAndBack();

signals:
    void ok();
};

#endif // HIGHSCORE_H
