#ifndef OPTIONS_H
#define OPTIONS_H

#include <QtGui/QWidget>
#include "globalStructs.h"

namespace Ui {
    class singleOpts;
}

class singleOpts : public QWidget {
    Q_OBJECT
public:
    singleOpts(int freeLength, SOptions opts, QWidget *parent = 0);
    ~singleOpts();

protected:
    void changeEvent(QEvent *e);

private:
    Ui::singleOpts *m_ui;
    void getOptions();
    void setOptions();
    SOptions opts;

public slots:
    void playSlot();
    void backSlot();
    void fullChanged();

signals:
    void playSignal(SOptions);
    void backSignal();
};

#endif // OPTIONS_H
