#ifndef SPLITOPTS_H
#define SPLITOPTS_H

#include <QtGui/QWidget>
#include "globalStructs.h"

namespace Ui {
    class splitOpts;
}

class splitOpts : public QWidget {
    Q_OBJECT
public:
    splitOpts(int freeLength, SOptions opts, QWidget *parent = 0);
    ~splitOpts();

protected:
    void changeEvent(QEvent *e);

private:
    Ui::splitOpts *m_ui;
    void getOptions();
    void setOptions();
    SOptions opts;

public slots:
    void playSlot();
    void backSlot();
    void fullChanged();

signals:
    void playSignal(SOptions);
    void backSignal();
};

#endif // SPLITOPTS_H
